#pragma once
#include <iomanip>
#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <cmath>
#include <cstdlib>
#include <gsl/gsl_spline.h>

#include "math/matrix.hh"
#include "commons.hh"
#include "xTableU.hh"

using namespace std;



namespace HELL {


  extern void SetRCmodeCFnew(unsigned int mode=0);  // mode=0 uses gammadot, mode=1 uses as*beta0

  extern double DeltaUqgRes(double x, double as, int nf, xTableU *tU, double muFrat, void *pars=NULL);
  extern double DeltaKhgRes(double x, double as, int nf, xTableU *tU, double muFrat, void *pars=NULL);
  //
  extern double DeltaCLRes (double x, double as, int nf, xTableU *tU, double muFrat, void *pars=NULL);
  extern double DeltaC2Res (double x, double as, int nf, xTableU *tU, double muFrat, void *pars=NULL);
  extern double DeltaMCLRes(double x, double as, int nf, xTableU *tU, double muFrat, void *pars=NULL);
  extern double DeltaMC2Res(double x, double as, int nf, xTableU *tU, double muFrat, void *pars=NULL);
  extern double DeltaMCLResAxial(double x, double as, int nf, xTableU *tU, double muFrat, void *pars=NULL);
  extern double DeltaMC2ResAxial(double x, double as, int nf, xTableU *tU, double muFrat, void *pars=NULL);
  extern double DeltaMCLResCC(double x, double as, int nf, xTableU *tU, double muFrat, void *pars=NULL);
  extern double DeltaMC2ResCC(double x, double as, int nf, xTableU *tU, double muFrat, void *pars=NULL);
  extern double DeltaMC3ResCC(double x, double as, int nf, xTableU *tU, double muFrat, void *pars=NULL);
  //
  extern double DeltaHggAuxRes(double x, double as, int nf, xTableU *tU, double muFrat, void *pars=NULL);
  extern double DeltaHggRes   (double x, double as, int nf, xTableU *tU, double muFrat, void *pars=NULL);
  //
  extern double DeltaCDYRes(double x, double as, int nf, xTableU *tU, double muFrat, void *pars=NULL);

};

