#include <iomanip>
#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <cmath>
#include <cstdlib>

#include "math/matrix.hh"

using namespace std;



namespace HELL {

  extern void SetRCmodeCFold(unsigned int mode=0);  // mode=0 uses gammadot, mode=1 uses as*beta0
  extern void SetRCvarCFold (bool var);  // var=true uses "Airy" anomalous dimension

  //extern dcomplex gamma0sing(dcomplex N, double nf);
  //extern dcomplex gamma1sing(dcomplex N, double nf);
  //extern dcomplex fmom(dcomplex N);
  extern dcomplex Delta1Gamma       (dcomplex Delta_gamma, dcomplex Delta_gammadot, dcomplex N, double as, double nf, void *pars=NULL);
  extern dcomplex Delta1GammaDot    (dcomplex Delta_gamma, dcomplex Delta_gammadot, dcomplex N, double as, double nf, void *pars=NULL);
  extern dcomplex Gamma0            (dcomplex Delta_gamma, dcomplex Delta_gammadot, dcomplex N, double as, double nf, void *pars=NULL);
  extern dcomplex Gamma0sq          (dcomplex Delta_gamma, dcomplex Delta_gammadot, dcomplex N, double as, double nf, void *pars=NULL);
  extern dcomplex Gamma0cb          (dcomplex Delta_gamma, dcomplex Delta_gammadot, dcomplex N, double as, double nf, void *pars=NULL);
  extern dcomplex Gamma1            (dcomplex Delta_gamma, dcomplex Delta_gammadot, dcomplex N, double as, double nf, void *pars=NULL);
  extern dcomplex Gamma0Gamma1      (dcomplex Delta_gamma, dcomplex Delta_gammadot, dcomplex N, double as, double nf, void *pars=NULL);
  extern dcomplex Gamma2            (dcomplex Delta_gamma, dcomplex Delta_gammadot, dcomplex N, double as, double nf, void *pars=NULL);
  extern dcomplex DeltaGammaResNLOqg(dcomplex Delta_gamma, dcomplex Delta_gammadot, dcomplex N, double as, double nf, void *pars=NULL);
  extern dcomplex DeltaLogR         (dcomplex Delta_gamma, dcomplex Delta_gammadot, dcomplex N, double as, double nf, void *pars=NULL);
  extern dcomplex DeltaUqg          (dcomplex Delta_gamma, dcomplex Delta_gammadot, dcomplex N, double as, double nf, void *pars=NULL);
  extern dcomplex DeltaUxi          (dcomplex Delta_gamma, dcomplex Delta_gammadot, dcomplex N, double as, double nf, void *pars=NULL);
  extern dcomplex DeltaDUxi         (dcomplex Delta_gamma, dcomplex Delta_gammadot, dcomplex N, double as, double nf, void *pars=NULL);
  extern dcomplex DeltaGammaPlusUqg (dcomplex Delta_gamma, dcomplex Delta_gammadot, dcomplex N, double as, double nf, void *pars=NULL);
  extern dcomplex oldDeltaCLRes     (dcomplex Delta_gamma, dcomplex Delta_gammadot, dcomplex N, double as, double nf, void *pars=NULL);
  extern dcomplex oldDeltaC2Res     (dcomplex Delta_gamma, dcomplex Delta_gammadot, dcomplex N, double as, double nf, void *pars=NULL);

};

