#pragma once
#include <iomanip>
#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <cmath>
#include <cstdlib>
#include <gsl/gsl_spline.h>

#include "commons.hh"

using namespace std;



namespace HELL {

  class xTableU {
  protected:
    double *xx;
    int Np1, Np2;
    double x_min, x_mid, x_max;
    double interpolate(double x);
    //
    int Nxi;
    //double *xi_, *logxi_, **xdU, **xdDU, *xdUqg;
    double *xi_, *logxi_, **xdU, *xdUqg;
    gsl_spline *dUspline;
    //gsl_interp_accel *acc;
    //void Init();
  public:
    xTableU(string filename);
    ~xTableU() { delete[] xx; delete[] xi_; delete[] logxi_; for(int i=0; i<Nxi; i++) {delete[] xdU[i]; } delete[] xdU; delete[] xdUqg; gsl_spline_free(dUspline); delete dUspline; };
    double evalU  (double x, double xi, double &deriv);
    //double evalDU (double x, double xi);
    double evalUqg(double x);
    double getXmin() { return x_min; };
  };


};

